#!/bin/bash
# {{ ansible_managed }}
#
# Create and use a new metadata index and force a rebuild from the backend-data.
#

TIMESTAMP=$(date +'%Y%m%d%H%M%S')
INDEX_VERSION={{ elasticsearch_metadata_index_version }}
INDEX_NAME={{ elasticsearch_metadata_index_name_prefix }}${INDEX_VERSION}_${TIMESTAMP}
INDEX_INTERNAL_NAME={{ elasticsearch_metadata_index_internal_name_prefix }}${INDEX_VERSION}_${TIMESTAMP}

# START -- MIGRATION FROM OLD NAME oersi_backend_metadata
OERSI_BACKEND_METADATA_STATUS=$(curl --silent --write-out '%{http_code}' --output /dev/null --netrc-file ~/conf/search_index_elastic_access "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/oersi_backend_metadata")
if [[ "$OERSI_BACKEND_METADATA_STATUS" == "200" ]]; then
  date +"*** %Y-%m-%d %H:%M:%S migrating deprecated index oersi_backend_metadata"
  read -r -d '' MIGRATE_OERSI_BACKEND_INDEX_QUERY << EOC
{
  "source": {
    "index": "oersi_backend_metadata"
  },
  "dest": {
    "index": "search_index_backend_metadata"
  },
  "script": {
    "inline": "ctx._source.extendedData = ctx._source.additionalData; ctx._source.remove(\"additionalData\");"
  }
}
EOC
  curl --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X POST --header 'Content-Type: application/json' --header 'Accept: application/json' -d "$MIGRATE_OERSI_BACKEND_INDEX_QUERY" "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/_reindex"
  curl --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X DELETE "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/oersi_backend_metadata"
  echo ""
fi
# END -- MIGRATION FROM OLD NAME oersi_backend_metadata

for INDEX in $INDEX_NAME $INDEX_INTERNAL_NAME; do
  date +"*** %Y-%m-%d %H:%M:%S creating index $INDEX"
  curl --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X PUT "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/${INDEX}"
  echo ""
done

date +"*** %Y-%m-%d %H:%M:%S write conf"
read -r -d '' QUERY << EOC
{
  "metadataIndexName": "${INDEX_NAME}",
  "extendedMetadataIndexName": "${INDEX_INTERNAL_NAME}"
}
EOC
curl --netrc-file {{ base_dir }}/conf/search_index_backend_access --header 'Content-Type: application/json' -H 'Accept: application/json' -d "$QUERY" -XPOST "{{ search_index_backend_internal_api_base_url }}/metadata-config"

date +"*** %Y-%m-%d %H:%M:%S write conf file"
# necessary for create/recreate-index-check during installation
cat >{{ base_dir }}/conf/search_index.conf <<EOL
SEARCH_INDEX_VERSION=$INDEX_VERSION
SEARCH_INDEX_FEATURE_SYNONYM={{ search_index_features_use_synonyms | string }}
EOL

reindex() {
  date +"*** %Y-%m-%d %H:%M:%S reindex $1"
  read -r -d '' REINDEX_QUERY << EOC
{
  "source": {
    "index": "search_index_backend_metadata",
    "_source": ["$2"]
  },
  "dest": {
    "index": "$1"
  },
  "script": {
    "source": "ctx._source = ctx._source.$2"
  }
}
EOC
  curl --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X POST --header 'Content-Type: application/json' --header 'Accept: application/json' -d "$REINDEX_QUERY" "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/_reindex"
  echo ""
}
reindex ${INDEX_NAME} data
reindex ${INDEX_INTERNAL_NAME} extendedData
date +"*** %Y-%m-%d %H:%M:%S reindex done"
